package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.TableShouyiYaopinxinxi;
import com.izouma.awesomeadmin.service.TableShouyiYaopinxinxiService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/tableShouyiYaopinxinxi")
public class TableShouyiYaopinxinxiController {

    @Autowired
    private TableShouyiYaopinxinxiService tableShouyiYaopinxinxiService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(TableShouyiYaopinxinxi record) {
        List<TableShouyiYaopinxinxi> pp = tableShouyiYaopinxinxiService.getTableShouyiYaopinxinxiList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getTableShouyiYaopinxinxi", method = RequestMethod.GET)
    @ResponseBody
    public Result getTableShouyiYaopinxinxi(@RequestParam(required = false, value = "id") String id) {
        TableShouyiYaopinxinxi data = tableShouyiYaopinxinxiService.getTableShouyiYaopinxinxiById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(TableShouyiYaopinxinxi record) {
        TableShouyiYaopinxinxi data = tableShouyiYaopinxinxiService.getTableShouyiYaopinxinxi(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, TableShouyiYaopinxinxi record) {
        Map<String, Object> result = new HashMap<>();

        List<TableShouyiYaopinxinxi> pp =tableShouyiYaopinxinxiService.getTableShouyiYaopinxinxiByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(TableShouyiYaopinxinxi record) {
        boolean num = tableShouyiYaopinxinxiService.createTableShouyiYaopinxinxi(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateTableShouyiYaopinxinxi(TableShouyiYaopinxinxi record) {
        boolean num = tableShouyiYaopinxinxiService.updateTableShouyiYaopinxinxi(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteTableShouyiYaopinxinxi(@RequestParam(required = true, value = "id") String id) {

        boolean num = tableShouyiYaopinxinxiService.deleteTableShouyiYaopinxinxi(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, TableShouyiYaopinxinxi record) throws Exception {

    List<TableShouyiYaopinxinxi> tableShouyiYaopinxinxis = tableShouyiYaopinxinxiService.getTableShouyiYaopinxinxiList(record);


        String sheetName = "Table_兽医_药品信息";
        String titleName = "Table_兽医_药品信息数据表";
        String fileName = "Table_兽医_药品信息表";
        int columnNumber = 11;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "药品编号" ,   "药品名称" ,   "计量单位" ,   "规格" ,   "主要成分" ,   "有效成分" ,   "单价" ,   "生产厂家" ,   "药品制定部门" ,   "FlagColumn"  };
        String[][] dataList = new String[tableShouyiYaopinxinxis.size()][11];

        for (int i = 0; i < tableShouyiYaopinxinxis.size(); i++) {

                        dataList[i][0] = String.valueOf(tableShouyiYaopinxinxis.get(i).getId());
                        dataList[i][1] = String.valueOf(tableShouyiYaopinxinxis.get(i).get药品编号());
                        dataList[i][2] = String.valueOf(tableShouyiYaopinxinxis.get(i).get药品名称());
                        dataList[i][3] = String.valueOf(tableShouyiYaopinxinxis.get(i).get计量单位());
                        dataList[i][4] = String.valueOf(tableShouyiYaopinxinxis.get(i).get规格());
                        dataList[i][5] = String.valueOf(tableShouyiYaopinxinxis.get(i).get主要成分());
                        dataList[i][6] = String.valueOf(tableShouyiYaopinxinxis.get(i).get有效成分());
                        dataList[i][7] = String.valueOf(tableShouyiYaopinxinxis.get(i).get单价());
                        dataList[i][8] = String.valueOf(tableShouyiYaopinxinxis.get(i).get生产厂家());
                        dataList[i][9] = String.valueOf(tableShouyiYaopinxinxis.get(i).get药品制定部门());
                        dataList[i][10] = String.valueOf(tableShouyiYaopinxinxis.get(i).getFlagcolumn());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

